Program Port_8243_32Bit;
Uses CRT;
const BA = $378;                         { LPT1 }
var n: Word;

procedure Setzen (Port_Nr,Wert: Byte);
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;       { D1=CS1=0 }
  If (Port_Nr div 4)=1 then CS := 2;       { D2=CS2=0 }
  Port [BA] := CS + 1;                     { D0=St=1 }
  Port [BA+2] := ((Port_Nr AND 3) + 4) XOR 11; { Steuerkommando }
  Port [BA] := CS;                         { D0=St=0 }
  Port [BA+2] := Wert XOR 11;              { Datenwort }
  Port [BA] := CS + 1;                     { D0=St=1 }
  Port [BA] := 6 + 1;                      { CS1=1, CS2=1 }
end;

function Lesen (Port_Nr : Byte): Byte;
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;       { D1=CS1=0 }
  If (Port_Nr div 4)=1 then CS := 2;       { D2=CS2=0 }
  Port [BA] := CS + 1;                     { D0=St=1 }
  Port [BA+2] := (Port_Nr AND 3) XOR 11;   { Steuerkommando }
  Port [BA] := CS;                         { D0=St=0 }
  Port [BA+2] := 15 XOR 11;                { Bus hochohmig }
  Lesen := Port[BA+2] AND 15 XOR 11;       { Daten lesen }
  Port [BA] := CS + 1;                     { D0=St=1 }
  Port [BA] := 6 + 1;                      { CS1=1, CS2=1 }
end;

procedure AND_Port (Port_Nr,Wert: Byte);
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;       { D1=CS1=0 }
  If (Port_Nr div 4)=1 then CS := 2;       { D2=CS2=0 }
  Port [BA] := CS + 1;                     { D0=St=1 }
  Port [BA+2] := ((Port_Nr AND 3) + 12) XOR 11; { Steuerkommando }
  Port [BA] := CS;                         { D0=St=0 }
  Port [BA+2] := Wert XOR 11;              { Datenwort }
  Port [BA] := CS + 1;                     { D0=St=1 }
  Port [BA] := 6 + 1;                      { CS1=1, CS2=1 }
end;

procedure OR_PORT (Port_Nr,Wert: Byte);
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;       { D1=CS1=0 }
  If (Port_Nr div 4)=1 then CS := 2;       { D2=CS2=0 }
  Port [BA] := CS + 1;                     { D0=St=1 }
  Port [BA+2] := ((Port_Nr AND 3) + 8) XOR 11; { Steuerkommando }
  Port [BA] := CS;                         { D0=St=0 }
  Port [BA+2] := Wert XOR 11;              { Datenwort }
  Port [BA] := CS + 1;                     { D0=St=1 }
  Port [BA] := 6 + 1;                      { CS1=1, CS2=1 }
end;

begin
  for n:=0 to 65535 do begin
    Setzen (0,lo(n) mod 16 );              { P0: Bits 0...3 }
    Setzen (1,lo(n) div 16);               { P1: Bits 4...7 }
    Setzen (2,hi(n) mod 16 );              { P2: Bits 8...11 }
    Setzen (3,hi(n) div 16);               { P3: Bits 12...15 }
    writeln (n,'  ', Lesen(4) + 16 * Lesen(5) { lesen: }
       + 256 * Lesen(6) + 4096 * Lesen(7) );  { P4 bis P7 }
  end;
end.
