Program Frequenzmessung;
Uses Crt;
const  BA = $3F8;            { COM 1 }

procedure Zeitgeber;
begin
  Port[$43] := $24;          { Timer 0, Mode 2, Lesen: Highbyte }
  Port[$40] := lo (59659);   { Teilerfaktor }
  Port[$40] := hi (59659);   { = 1193180 / 20 }
end;

procedure Uhr;
begin
  Port[$43] := $36;          { Timer 0, Mode 3 }
  Port[$40] := 0;            { Teilerfaktor }
  Port[$40] := 0;            { = 65536 }
end;

function Frequenz (Kanal: Byte): Integer;
var Dummy, Timer, Timer_alt : Integer;
    Eingang, Eingang_alt, Zeit : Byte;
    Portwert : Byte;
    Zaehler : Integer;
begin
 Portwert := 16;                      { CTS }
 if Kanal=2 then Portwert := 32;      { DSR }
 if Kanal=3 then Portwert := 64;      { RI }
 if Kanal=4 then Portwert := 128;     { DCD }
 Zaehler := 0;
 Zeit := 0;
 Inline ($FA);                        { Interrupt sperren }
 Timer := Port[$40] and 128;          { hchstwertiges Bit }
 repeat;
   Timer_alt := Timer;
   Timer := Port[$40] and 128;
 until Timer > Timer_alt;             { 1. Timer-berlauf }
 Eingang_alt := Port[BA+6] AND Portwert;
 repeat
     Timer_alt := Timer;
     Eingang := Port[BA+6] AND Portwert;   { Flanken zhlen }
     if Eingang > Eingang_alt then Zaehler := Zaehler + 1;
     Eingang_alt := Eingang;
     Timer := Port[$40] and 128;      { berlufe zhlen }
     If Timer > Timer_alt then Zeit := Zeit +1;
 until Zeit = 20;                     { 1 Sekunde }
 Inline ($FB);                        { Interrupt freigeben }
 Frequenz := Zaehler;
end;

begin
  Zeitgeber;
  repeat
    writeln ('Kanal1: ',Frequenz(1), ' Hz');
    writeln ('Kanal2: ',Frequenz(2), ' Hz');
    writeln ('Kanal3: ',Frequenz(3), ' Hz');
    writeln ('Kanal4: ',Frequenz(4), ' Hz');
  until KeyPressed;
  Uhr;
end.
