Unit I2C_LPT1;

Interface

Uses CRT;
const BA = $378;             { LPT1 }

procedure I2C_Init;
procedure Start;
procedure Stop;
procedure Acknowledge;
procedure KeinAcknowledge;
procedure Ausgeben (Wert : Byte);
function  Einlesen : Byte;

Implementation

procedure I2C_Init;
begin
  Port [BA+2] := 0;          { SCL=1, SDA=1 }
end;

procedure Start;
begin
  Port [BA+2] := 1;          { SDA=0 }
  Port [BA+2] := 3;          { SCL=0 }
end;

procedure Stop;
begin
  Port [BA+2] := 3;          { SCL=0, SDA=0 }
  Port [BA+2] := 1;          { SCL=1 }
  Port [BA+2] := 0;          { SDA=1 }
end;

procedure Acknowledge;
var m : Byte;
begin
  Port [BA+2] := 3;          { SCL=0, SDA=0 }
  Port [BA+2] := 1;          { SCL=1 }
  for m:= 1 to 5 do;         { Warteschleife }
  Port [BA+2] := 3;          { SCL=0 }
end;

procedure KeinAcknowledge;
var m : Byte;
begin
  Port [BA+2] := 2;          { SCL=0, SDA=1 }
  Port [BA+2] := 0;          { SCL=1 }
  for m:= 1 to 5 do;         { Warteschleife }
  Port [BA+2] := 2;          { SCL=0 }
end;

procedure Ausgeben (Wert : Byte);
var Bitwert, Portwert, n, m : Byte;
begin
  Bitwert := 128;
  for n:= 1 to 8 do begin
    if (Wert and Bitwert) = Bitwert then Portwert := 2 else
       Portwert := 3;
    Port [BA+2] := Portwert ;       { SDA setzen }
    Port [BA+2] := Portwert - 2;    { SCL=1 }
    for m:= 1 to 5 do;              { Warteschleife }
    Port [BA+2] := Portwert ;       { SCL=0 }
    Bitwert := Bitwert div 2;
  end;
  Port [BA+2] := 2;                 { SDA=1, SCL=0 }
  Port [BA+2] := 0;                 { SCL=1, SDA lesen }
  for m:= 1 to 5 do;                { Warteschleife }
  if (Port[BA+2] AND 1) = 0 then writeln ('IC antwortet nicht');
  Port [BA+2] := 2;                 { SCL=0 }
end;

function Einlesen : Byte;
var Bitwert, Wert, n, m : Byte;
begin
  Port [BA+2] := 2;                 { SDA=1, SCL=0 }
  Bitwert := 128;
  Wert := 0;
  for n:= 1 to 8 do begin
    Port [BA+2] := 0;               { SCL=1, SDA lesen }
    for m:= 1 to 5 do;              { Warteschleife }
    If (Port [BA+2] AND 1) = 0 then Wert := Wert + Bitwert;
    Port [BA+2] := 2;               { SCL=0 }
    Bitwert := Bitwert div 2;
  end;
  Einlesen := Wert;
end;

begin
 I2C_Init
end.
