Program NPN_Transistor;
Uses Crt;
const  BA = $3F8;                     { COM 1 }
var  Negativ, Positiv, Zeitfaktor : Real;
     Ib, Ic, V : Real;

function Zaehler (Kanal:Byte): Integer;
var Eingang, n : Integer;
begin
 Eingang:=16;                         { CTS }
 If Kanal=2 then Eingang := 32;       { DSR }
 If Kanal=3 then Eingang := 64;       { RI }
 If Kanal=4 then Eingang := 128;      { DCD }
 N := 0;
 delay (100);
 Inline ($FA);                        { Interrupt sperren }
 Port [BA+4] := 3;                    { DTR=1, RTS=1 }
 repeat
   N := N +1;                         { zhlen }
 until ((Port[BA+6] and Eingang)=0);  { bis Eingang = 0 }
 Port[BA+4] := 2;                     { DTR=0; RTS=1 }
 Inline ($FB);                        { Interrupt freigeben }
 Zaehler := N;
end;

procedure Kalibrieren;
begin
  Zeitfaktor := -(Zaehler(1)/ln(1-Negativ/(Positiv+Negativ)));
end;

function Spannung (Kanal: Integer) : Real;
begin
  Spannung :=(Negativ+Positiv)*(1-exp(-Zaehler(Kanal)/Zeitfaktor))-Negativ;
end;

begin
 Negativ := 8.2;
 Positiv := 8.2;
 Kalibrieren;
 ClrScr;
 repeat
  GotoXY (1,2);
  writeln ('Ubat = ',Spannung (1) :3:2, ' V   ');
  writeln ('Uin =  ',Spannung (2) :3:2, ' V   ');
  writeln ('Ube =  ',Spannung (3) :3:2, ' V   ');
  writeln ('Uce =  ',Spannung (4) :3:2, ' V   ');
  Ib := (Spannung (2) - Spannung (3)) * 10;
  writeln ('Ib =   ',Ib :3:1,' A   ');
  Ic := (Spannung (1) - Spannung (4)) * 1; {1k}
  writeln ('Ic =   ',Ic :3:2,' mA   ');
  If Ib>0 then V:= Ic/Ib * 1000 else V := 0;
  writeln ('V =    ',V : 3:0,'      ');
 until KeyPressed;
end.
